-- lower numbers mean brighter light
-- max brightness is 20 for simplicity in my code
brightness = 20

-- is the help screen displayed?
helpDisplayed = false

function on.arrowUp()
  -- make sure we are not already at max brightness
  if brightness ~= 0 then
    -- increase brightness by making brightness var lower
    brightness = brightness - 1
    platform.window:invalidate()
  end
end

function on.arrowDown()
  -- make sure we are not already at min brightness
  if brightness ~= 20 then
    -- decrease brightness by making brightness var higher
    brightness = brightness + 1
    platform.window:invalidate()
  end
end

function on.escapeKey()
  -- redraw window for reasons
  platform.window:invalidate()
  helpDisplayed = false
end

function on.paint(gc)
  -- if the brightness is 0, don't add any black
  if brightness ~= 0 then
    -- draw 17 lines at their appropriate thickness to controll brightness
    for lines = 0, 16 do
      gc:fillRect(lines * 20, 0, brightness, 215)
    end
  end
  if helpDisplayed == true then
    -- display some help for the user
    gc:setColorRGB(255, 255, 255)
    gc:fillRect(20, 20, 280, 170)
    gc:setColorRGB(0, 0, 0)
    gc:drawString("Up arrow to increase brightness;", 40, 40)
    gc:drawString("Down arrow to decrease brightness;", 40, 60)
    gc:drawString("Esc to close this menu", 40, 80)
  end
end

function brightnessSet(val)
  -- function to set brightness for reasons
  brightness = val
  platform.window:invalidate()
end

function displayHelp()
  -- tell on.paint to display some help
  helpDisplayed = true
  platform.window:invalidate()
end

menu = {
 {"Presets",
   {"Max", function() brightnessSet(0) end},
   {"Mid", function() brightnessSet(10) end},
   {"Min", function() brightnessSet(20) end},
 },
 {"Help", 
   {"No really, help me", displayHelp},
 }
} toolpalette.register(menu)